/*-----------------------------------------------------------*/
/*                    Fetomn - The game                     */
/*                       (graficos.c)                        */
/*                                                           */
/*                                                           */
/*-----------------------------------------------------------*/

#include <stdio.h>
#include <math.h>
#include <allegro.h>

#include "fetoman.h"
#include "juego.h"


BITMAP *superfondo; //nubes, montaas...
BITMAP *fondo; //arboles, pilares, mierdas...
BITMAP *frente; //troncos, pisos, cosas...

BITMAP *fetoman[6];
BITMAP *objetos[10];

float worldx;
float worldy;
float vel_worldx=0;
float fmanx;
float fmany;
float vel_fmanx;
float vel_fmany;
int fman_dir;   //direccion a la que mira fetoman -1=izq,0=cent,1=der
float fman_paso;
int fman_suelo = TRUE;
int fman_vivo = TRUE;
int nivel_acabao=FALSE;

int balas[20][4] = 
	{{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},
	{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},
	{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},
	{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}}; //vivo,x,y,tipo
		
int objeto[20][10] = //vivo,x,y,tipo,xmin,xmax,dirx,velx
	{{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}; 

int posiciona_fman(int nivel)
{
	
	switch(nivel)
	{
		case 1:
		{
		worldx=0;
		worldy=0;
		fmanx=10;
		fmany=230;
		vel_fmanx=0;
		vel_fmany=0;
		fman_dir=1;
		fman_paso=1;
		fman_vivo=TRUE;
		nivel_acabao=FALSE;
		}
	}

}


void teclado(int nivel)
{
	int i;
	int derecha,izquierda,espacio;
	
	
	derecha   = key[KEY_RIGHT];
	izquierda = key[KEY_LEFT];
	espacio   = key[KEY_SPACE];
	
	if((derecha && vel_fmanx<2) || (nivel_acabao && vel_fmanx<2)) vel_fmanx+=0.2;
	if(izquierda && vel_fmanx>-2) vel_fmanx-=0.2;
	
	if(vel_fmanx>0){
		vel_fmanx-=0.1;
		if(vel_fmanx<0) vel_fmanx=0;
		}
	if(vel_fmanx<0){
		vel_fmanx+=0.1;
		if(vel_fmanx>0) vel_fmanx=0;
		}
	
	if(derecha && !izquierda) fman_dir=1;
	else if(izquierda && !derecha) fman_dir=-1;
		
	if(izquierda || derecha || nivel_acabao)
	{
		fman_paso+=0.2;
		if(fman_paso>=4) fman_paso=0;
	}
	else if(!izquierda && !derecha) fman_paso=0;

		
	if(espacio && vel_fmany==0) vel_fmany=5;
	else if(espacio && vel_fmany>0) vel_fmany*=1.025;
	
	vel_fmany-=0.3;
	if(vel_fmany<-8) vel_fmany=-8;
	
	
	fmanx+=vel_fmanx;
	fmany+=vel_fmany;


	if(fmany>0 && fmany<239)
	if(!(getpixel(frente,fmanx+42,225-fmany)!=makecol(255,0,255) &&
		getpixel(frente,fmanx,225-fmany)!=makecol(255,0,255)))
	{
		if(getpixel(frente,fmanx+42,225-fmany)!=makecol(255,0,255))
		{
			fmanx-=2.1;
		}
		if(getpixel(frente,fmanx,225-fmany)!=makecol(255,0,255))
		{
			fmanx+=2.1;
		}
	}
	
	if(fmany>0 && fmany<239){
		if(getpixel(frente,fmanx+22,239-fmany)!=makecol(255,0,255))
		{
			while(getpixel(frente,fmanx+22,239-fmany)!=makecol(255,0,255))
			{
				fmany++;
			}
			vel_fmany=0;
		}
	}
	
	else if(fmany<-60) fman_vivo=FALSE;
	if(fmany<-100) fmany=-100;
	
	for(i=0;i<20;i++)
	{
		if(objeto[i][0]==1)
			{
			switch(objeto[i][3])
			{
				case 0:
					if((abs(fmanx+22-objeto[i][1]-6)<20) && 
					   (abs(objeto[i][2]-fmany-12)<13))
					{
						if(fman_suelo==FALSE && vel_fmany<0){
						objeto[i][0]=0;
						vel_fmany=5;
						}
						else if(fman_suelo==TRUE){
						vel_fmany=5;
						vel_fmanx+=6*(-fman_dir);
						}
					}
					objeto[i][1]+=objeto[i][6]*objeto[i][7]; //x=velx*dirx
					if(objeto[i][1]<objeto[i][4] || objeto[i][1]>objeto[i][5]) objeto[i][7]=-objeto[i][7];  
					break;
				
				case 1:
					if((abs(fmanx+22-objeto[i][1]-17)<26) && 
					   (abs(objeto[i][2]-fmany-12)<10))
					{
						objeto[i][4]=4;
						vel_fmany=objeto[i][5];
					}
					else if(objeto[i][4]>0) objeto[i][4]--;						
					break;
				
			}
		}
	}
	
	if(getpixel(frente,fmanx+22,240-fmany)!=makecol(255,0,255)) fman_suelo=TRUE;
		else fman_suelo=FALSE;	
		
	if(fmanx-worldx>240) worldx=fmanx+240;
	if(fmanx-worldx<0) worldx=fmanx;
	
	if(fmanx-worldx>220) vel_worldx+=0.5;
	if(fmanx-worldx<20) vel_worldx-=0.5;
	
	if(fmanx-worldx>180) vel_worldx+=0.2;
	if(fmanx-worldx<60) vel_worldx-=0.2;
	
	worldx+=vel_worldx;
	if(worldx<0) {worldx=0; vel_worldx=0;}	
	if(worldx>3950) {worldx=3950; vel_worldx=0;}
	if(fmanx>4200) nivel_acabao=TRUE;
	if(vel_worldx>0){
		vel_worldx-=0.1;
		if(vel_worldx<0) vel_worldx=0;
		}
	if(vel_worldx<0){
		vel_worldx+=0.1;
		if(vel_worldx>0) vel_worldx=0;
		}
		
}

void carga_graficos(int nivel)
{
	int i=0;
	DATAFILE *dsuperfondos;
	DATAFILE *dfondos;
	DATAFILE *dfrentes;
	DATAFILE *dfetoman;
	DATAFILE *dobjetos;
	
	dsuperfondos = load_datafile("../data/superfondos.dat");
	
	superfondo = create_bitmap(840,240);
	
	switch(nivel)
	{
		case 0:
		
			break;
		
		case 1: 
		
			blit(dsuperfondos[0].dat,superfondo,0,0,0,0,840,240);
			break;
		
	}
	unload_datafile(dsuperfondos);

	dfondos = load_datafile("../data/fondos.dat");
	
	fondo = create_bitmap(1680,240);
	clear(fondo);
	
	switch(nivel)
	{
		case 0:
		
			break;
		
		case 1: 
		
			blit(dfondos[0].dat,fondo,0,0,0,0,320,240);
			blit(dfondos[0].dat,fondo,0,0,320,0,320,240);
			blit(dfondos[0].dat,fondo,0,0,640,0,320,240);
			blit(dfondos[0].dat,fondo,0,0,960,0,320,240);
			blit(dfondos[0].dat,fondo,0,0,1280,0,320,240);
			blit(dfondos[0].dat,fondo,0,0,1600,0,320,240);
			break;
		
	}
	unload_datafile(dfondos);
	
	for(i=0;i<6;i++)
	{
		fetoman[i] = create_bitmap(42,55);
	}
	dfetoman = load_datafile("../data/fetoman.dat");
	blit(dfetoman[0].dat,fetoman[0],0,0,0,0,42,55);
	blit(dfetoman[1].dat,fetoman[1],0,0,0,0,42,55);
	blit(dfetoman[0].dat,fetoman[2],0,0,0,0,42,55);
	blit(dfetoman[2].dat,fetoman[3],0,0,0,0,42,55);
	blit(dfetoman[3].dat,fetoman[4],0,0,0,0,42,55);

	unload_datafile(dfetoman);
	
	
	dobjetos = load_datafile("../data/objetos.dat");
	
	objetos[0] = create_bitmap(12,20); //bebe
	blit(dobjetos[0].dat,objetos[0],0,0,0,0,12,20);
	objetos[1] = create_bitmap(35,16);  //muelle1
	blit(dobjetos[1].dat,objetos[1],0,0,0,0,35,16);
	objetos[2] = create_bitmap(35,16); //muelle2
	blit(dobjetos[2].dat,objetos[2],0,0,0,0,35,16);
	
	unload_datafile(dobjetos);
	
	switch(nivel)
	{
		case 0:
		
			break;
		
		case 1: 
		
			i=0;
			objeto[i][0] = 1; objeto[i][1] = 870; objeto[i][2] = 119; objeto[i][3] = 0; //vivo,x,y,tipo bebe
			objeto[i][4] = 750; objeto[i][5] = 880; objeto[i][6] = 1; objeto[i][7] = 1; //mix,max,vel,dir
			i=1;
			objeto[i][0] = 1; objeto[i][1] = 350; objeto[i][2] = 36; objeto[i][3] = 0;  
			objeto[i][4] = 300; objeto[i][5] = 450; objeto[i][6] = 1; objeto[i][7] = -1;
			i=2;
			objeto[i][0] = 1; objeto[i][1] = 1940; objeto[i][2] = 15; objeto[i][3] = 1;  //vivo,x,y,tipo salto
			objeto[i][4] = 0; objeto[i][5] = 7; objeto[i][6] = 0; objeto[i][7] = 0; //alargamiento,velsalto,
			i=3;
			objeto[i][0] = 1; objeto[i][1] = 2670; objeto[i][2] = 67; objeto[i][3] = 1;  //vivo,x,y,tipo salto
			objeto[i][4] = 0; objeto[i][5] = 8; objeto[i][6] = 0; objeto[i][7] = 0; //alargamiento,velsalto,
			i=4;
			objeto[i][0] = 1; objeto[i][1] = 2805; objeto[i][2] = 67; objeto[i][3] = 1;  //vivo,x,y,tipo salto
			objeto[i][4] = 0; objeto[i][5] = 8; objeto[i][6] = 0; objeto[i][7] = 0; //alargamiento,velsalto,
			i=5;
			objeto[i][0] = 1; objeto[i][1] = 2420; objeto[i][2] = 70; objeto[i][3] = 0; //vivo,x,y,tipo bebe
			objeto[i][4] = 2410; objeto[i][5] = 2480; objeto[i][6] = 1; objeto[i][7] = 1; //mix,max,vel,dir
			i=6;
			objeto[i][0] = 1; objeto[i][1] = 3070; objeto[i][2] = 15; objeto[i][3] = 1;  //vivo,x,y,tipo salto
			objeto[i][4] = 0; objeto[i][5] = 7; objeto[i][6] = 0; objeto[i][7] = 0; //alargamiento,velsalto,
			i=7;
			objeto[i][0] = 1; objeto[i][1] = 3170; objeto[i][2] = 15; objeto[i][3] = 1;  //vivo,x,y,tipo salto
			objeto[i][4] = 0; objeto[i][5] = 7; objeto[i][6] = 0; objeto[i][7] = 0; //alargamiento,velsalto,
			i=8;
			objeto[i][0] = 1; objeto[i][1] = 3270; objeto[i][2] = 15; objeto[i][3] = 1;  //vivo,x,y,tipo salto
			objeto[i][4] = 0; objeto[i][5] = 7; objeto[i][6] = 0; objeto[i][7] = 0; //alargamiento,velsalto,
			i=9;
			objeto[i][0] = 1; objeto[i][1] = 3540; objeto[i][2] = 46; objeto[i][3] = 1;  //vivo,x,y,tipo salto
			objeto[i][4] = 0; objeto[i][5] = 5.5; objeto[i][6] = 0; objeto[i][7] = 0; //alargamiento,velsalto,
		


			break;
		
	}
	
	dfrentes = load_datafile("../data/frentes.dat");
	
	frente = create_bitmap(4320,240);
	clear(frente);
	
	switch(nivel)
	{
		case 0:
		
			break;
		
		case 1: 
		
			blit(dfrentes[0].dat,frente,0,0,0,0,4320,240);
			break;
		
	}
	unload_datafile(dfrentes);
	

	
}

void render(int nivel)
{
	
	int i;

	blit(superfondo,buffer,worldx/8,0,0,0,320,240);
	masked_blit(fondo,buffer,worldx/3,0,0,0,320,240);
	masked_blit(frente,buffer,worldx,0,0,0,320,240);
	
	if(fman_paso>=0 && fman_paso<4 && fman_suelo==TRUE)
	{
		if(fman_dir==1) draw_sprite(buffer,fetoman[0+(int)fman_paso],fmanx-worldx,240-55-fmany);
		else if(fman_dir==-1) draw_sprite_h_flip(buffer,fetoman[0+(int)fman_paso],fmanx-worldx,240-55-fmany);
	}
	else if(fman_suelo==FALSE)
	{
		if(fman_dir==1) draw_sprite(buffer,fetoman[4],fmanx-worldx,240-55-fmany);
		else draw_sprite_h_flip(buffer,fetoman[4],fmanx-worldx,240-55-fmany);
	}
	
	for(i=0;i<20;i++)
	{
		if(objeto[i][0]==1){
		if(abs(objeto[i][1]-fmanx)<450){
			if(objeto[i][3]==0)
			{
				if(objeto[i][7]==1)
					draw_sprite(buffer,objetos[0],objeto[i][1]-worldx,239-objeto[i][2]);
				if(objeto[i][7]==-1)
				draw_sprite_h_flip(buffer,objetos[0],objeto[i][1]-worldx,239-objeto[i][2]);
			}
			else if(objeto[i][3]==1)
			{
				if(objeto[i][4]==0)
					draw_sprite(buffer,objetos[1],objeto[i][1]-worldx,239-objeto[i][2]);
				if(objeto[i][4]>0)
					draw_sprite(buffer,objetos[2],objeto[i][1]-worldx,239-objeto[i][2]);
			}	
			
		}}
	}
	set_palette(dfuentes[5].dat);
	textprintf_right(buffer,dfuentes[0].dat,318,232,-1,"Fetoman - The Game v0.1");
	set_palette(dfuentes[4].dat);
	textprintf(buffer,dfuentes[0].dat,1,1,-1,"FPS: %d",fps);
	set_palette(dfuentes[3].dat);
	if(nivel_acabao)
	{
		set_palette(dfuentes[2].dat);
		textprintf_centre(buffer,dfuentes[0].dat,160,100,  -1,"Fetoman RIP");
		textprintf_centre(buffer,dfuentes[0].dat,160,120,  -1,"press enter");
	}
	if(nivel_acabao)
	{
		set_palette(dfuentes[2].dat);
		textprintf_centre(buffer,dfuentes[0].dat,160,100,  -1,"Nivel %d acabado",nivel);
		textprintf_centre(buffer,dfuentes[0].dat,160,120,  -1,"press enter");
	}
	
}

